User account creation filtered due to spam.

Bug 42834 - memcpy folding overeager
Summary: memcpy folding overeager
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: middle-end (show other bugs)
Version: 4.5.0
: P3 normal
Target Milestone: 4.6.0
Assignee: Richard Biener
URL:
Keywords: alias, wrong-code
: 45883 (view as bug list)
Depends on:
Blocks:
 
Reported: 2010-01-21 17:04 UTC by Richard Biener
Modified: 2011-12-22 02:28 UTC (History)
5 users (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed: 2010-01-21 17:09:41


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Richard Biener 2010-01-21 17:04:30 UTC
We fold memcpy to direct assignments based on types of the pointed-to types
of its arguments.  This is completely wrong for C++ and wrong for C if
neither source nor destination has a declared type.  memcpy transfers the
dynamic type of objects.

int main()
{
  int i = 0;
  float f = 1.0;
  int *p = (int *)&f;
  __builtin_memcpy (&i, p, 4);
  if (*(float *)&i != 1.0)
    __builtin_abort ();
  return 0;
}

we already fold the memcpy to

  i = *(int * {ref-all})p;

but that creates an access to i via an lvalue of type int.  It needs to
be all done via a ref-all access, thus

*(<type-large-enough> * {ref-all})&i = *(<type-large-enough> * {ref-all})p;

In C the testcase would invoke undefined behavior as i has a declared type
but it is valid C++.

The issue arises fixing std::tr1::functional::swap wrt its accesses to
_Any_data.

      void swap(function& __x)
      {
        _Any_data __old_functor;
        __builtin_memcpy (&__old_functor, &_M_functor, sizeof (_Any_data));
        __builtin_memcpy (&_M_functor, &__x._M_functor, sizeof (_Any_data));
        __builtin_memcpy (&__x._M_functor, &__old_functor, sizeof (_Any_data));
        _Manager_type __old_manager = _M_manager;

is folded back to

  __old_functor = D.13016.D.8817._M_functor;
  D.13016.D.8817._M_functor = f.D.8817._M_functor;
  f.D.8817._M_functor = __old_functor;

which wasn't the point of the whole excercise.
Comment 1 Richard Biener 2010-01-21 17:09:41 UTC
Mine.
Comment 2 Richard Biener 2010-01-22 12:29:34 UTC
          /* With memcpy, it is possible to bypass aliasing rules, so without
             this check i.e. execute/20060930-2.c would be misoptimized,
             because it use conflicting alias set to hold argument for the
             memcpy call.  This check is probably unnecessary with
             -fno-strict-aliasing.  Similarly for destvar.  See also
             PR29286.  */
          else if (!var_decl_component_p (srcvar))
            srcvar = NULL_TREE;

this is ok for C but not enough for C++.  For C++ we need to unconditionally
zero srcvar with only the memcpy statement to look at.

A propagation pass might be able to figure out the dynamic type of the
memory we are copying.  Might fit well into a pass to propagate alignment
information.
Comment 3 Richard Biener 2010-01-22 12:36:18 UTC
Another possible way is to have a block-copy operation in gimple that
would do the copy with alias-set zero and avoids the address-taking.
Comment 4 Richard Biener 2010-06-21 11:18:48 UTC
Subject: Bug 42834

Author: rguenth
Date: Mon Jun 21 11:18:26 2010
New Revision: 161067

URL: http://gcc.gnu.org/viewcvs?root=gcc&view=rev&rev=161067
Log:
2010-06-21  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42834
	* builtins.c (fold_builtin_memory_op): Use ref-all types
	for all memcpy foldings.
	* expr.c (store_expr): Handle MEM_REFs from STRING_CSTs.

        testsuite/
	* c-c++-common/torture/pr42834.c: New testcase.
	* gcc.dg/tree-prof/stringop-1.c: Adjust.
	* gfortran.dg/array_memcpy_3.f90: Likewise.
	* gfortran.dg/array_memcpy_4.f90: Likewise.

Added:
    branches/mem-ref2/gcc/testsuite/c-c++-common/torture/pr42834.c
Modified:
    branches/mem-ref2/gcc/ChangeLog.mem-ref2
    branches/mem-ref2/gcc/builtins.c
    branches/mem-ref2/gcc/expr.c
    branches/mem-ref2/gcc/testsuite/gcc.dg/tree-prof/stringop-1.c
    branches/mem-ref2/gcc/testsuite/gfortran.dg/array_memcpy_3.f90
    branches/mem-ref2/gcc/testsuite/gfortran.dg/array_memcpy_4.f90

Comment 5 Richard Biener 2010-07-01 08:49:38 UTC
Subject: Bug 42834

Author: rguenth
Date: Thu Jul  1 08:49:19 2010
New Revision: 161655

URL: http://gcc.gnu.org/viewcvs?root=gcc&view=rev&rev=161655
Log:
2010-07-01  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42834
	PR middle-end/44468
	* doc/gimple.texi (is_gimple_mem_ref_addr): Document.
	* doc/generic.texi (References to storage): Document MEM_REF.
	* tree-pretty-print.c (dump_generic_node): Handle MEM_REF.
	(print_call_name): Likewise.
	* tree.c (recompute_tree_invariant_for_addr_expr): Handle MEM_REF.
	(build_simple_mem_ref_loc): New function.
	(mem_ref_offset): Likewise.
	* tree.h (build_simple_mem_ref_loc): Declare.
	(build_simple_mem_ref): Define.
	(mem_ref_offset): Declare.
	* fold-const.c: Include tree-flow.h.
	(operand_equal_p): Handle MEM_REF.
	(build_fold_addr_expr_with_type_loc): Likewise.
	(fold_comparison): Likewise.
	(fold_unary_loc): Fold
	VIEW_CONVERT_EXPR <T1, MEM_REF <T2, ...>> to MEM_REF <T1, ...>.
	(fold_binary_loc): Fold MEM[&MEM[p, CST1], CST2] to MEM[p, CST1 + CST2],
	fold MEM[&a.b, CST2] to MEM[&a, offsetof (a, b) + CST2].
	* tree-ssa-alias.c (ptr_deref_may_alias_decl_p): Handle MEM_REF.
	(ptr_deref_may_alias_ref_p_1): Likewise.
	(ao_ref_base_alias_set): Properly differentiate base object for
	offset and TBAA.
	(ao_ref_init_from_ptr_and_size): Use MEM_REF.
	(indirect_ref_may_alias_decl_p): Handle MEM_REFs properly.
	(indirect_refs_may_alias_p): Likewise.
	(refs_may_alias_p_1): Likewise.  Remove pointer SSA name def
	chasing code.
	(ref_maybe_used_by_call_p_1): Handle MEM_REF.
	(call_may_clobber_ref_p_1): Likewise.
	* dwarf2out.c (loc_list_from_tree): Handle MEM_REF.
	* expr.c (expand_assignment): Handle MEM_REF.
	(store_expr): Handle MEM_REFs from STRING_CSTs.
	(store_field): If expanding a MEM_REF of a non-addressable
	decl use bitfield operations.
	(get_inner_reference): Handle MEM_REF.
	(expand_expr_addr_expr_1): Likewise.
	(expand_expr_real_1): Likewise.
	* tree-eh.c (tree_could_trap_p): Handle MEM_REF.
	* alias.c (ao_ref_from_mem): Handle MEM_REF.
	(get_alias_set): Likewise.  Properly handle VIEW_CONVERT_EXPRs.
	* tree-data-ref.c (dr_analyze_innermost): Handle MEM_REF.
	(dr_analyze_indices): Likewise.
	(dr_analyze_alias): Likewise.
	(object_address_invariant_in_loop_p): Likewise.
	* gimplify.c (mark_addressable): Handle MEM_REF.
	(gimplify_cond_expr): Build MEM_REFs.
	(gimplify_modify_expr_to_memcpy): Likewise.
	(gimplify_init_ctor_preeval_1): Handle MEM_REF.
	(gimple_fold_indirect_ref): Adjust.
	(gimplify_expr): Handle MEM_REF.  Gimplify INDIRECT_REF to MEM_REF.
	* tree.def (MEM_REF): New tree code.
	* tree-dfa.c: Include toplev.h.
	(get_ref_base_and_extent): Handle MEM_REF.
	(get_addr_base_and_unit_offset): New function.
	* emit-rtl.c (set_mem_attributes_minus_bitpos): Handle MEM_REF.
	* gimple-fold.c (may_propagate_address_into_dereference): Handle
	MEM_REF.
	(maybe_fold_offset_to_array_ref): Allow possibly out-of bounds
	accesses if the array has just one dimension.  Remove always true
	parameter.  Do not require type compatibility here.
	(maybe_fold_offset_to_component_ref): Remove.
	(maybe_fold_stmt_indirect): Remove.
	(maybe_fold_reference): Remove INDIRECT_REF handling.
	Fold back to non-MEM_REF.
	(maybe_fold_offset_to_address): Simplify.  Deal with type
	mismatches here.
	(maybe_fold_reference): Likewise.
	(maybe_fold_stmt_addition): Likewise.  Also handle
	&ARRAY + I in addition to &ARRAY[0] + I.
	(fold_gimple_assign): Handle ADDR_EXPR of MEM_REFs.
	(gimple_get_relevant_ref_binfo): Handle MEM_REF.
	* cfgexpand.c (expand_debug_expr): Handle MEM_REF.
	* tree-ssa.c (useless_type_conversion_p): Make most pointer
	conversions useless.
	(warn_uninitialized_var): Handle MEM_REF.
	(maybe_rewrite_mem_ref_base): New function.
	(execute_update_addresses_taken): Implement re-writing of MEM_REFs
	to SSA form.
	* tree-inline.c (remap_gimple_op_r): Handle MEM_REF, remove
	INDIRECT_REF handling.
	(copy_tree_body_r): Handle MEM_REF.
	* gimple.c (is_gimple_addressable): Adjust.
	(is_gimple_address): Likewise.
	(is_gimple_invariant_address): ADDR_EXPRs of MEM_REFs with
	invariant base are invariant.
	(is_gimple_min_lval): Adjust.
	(is_gimple_mem_ref_addr): New function.
	(get_base_address): Handle MEM_REF.
	(count_ptr_derefs): Likewise.
	(get_base_loadstore): Likewise.
	* gimple.h (is_gimple_mem_ref_addr): Declare.
	(gimple_call_fndecl): Handle invariant MEM_REF addresses.
	* tree-cfg.c (verify_address): New function, split out from ...
	(verify_expr): ... here.  Use for verifying ADDR_EXPRs and
	the address operand of MEM_REFs.  Verify MEM_REFs.  Reject
	INDIRECT_REFs.
	(verify_types_in_gimple_min_lval): Handle MEM_REF.  Disallow
	INDIRECT_REF.  Allow conversions.
	(verify_types_in_gimple_reference): Verify VIEW_CONVERT_EXPR of
	a register does not change its size.
	(verify_types_in_gimple_reference): Verify MEM_REF.
	(verify_gimple_assign_single): Disallow INDIRECT_REF.
	Handle MEM_REF.
	* tree-ssa-operands.c (opf_non_addressable, opf_not_non_addressable):
	New.
	(mark_address_taken): Handle MEM_REF.
	(get_indirect_ref_operands): Pass through opf_not_non_addressable.
	(get_asm_expr_operands): Pass opf_not_non_addressable.
	(get_expr_operands): Handle opf_[not_]non_addressable.
	Handle MEM_REF.  Remove INDIRECT_REF handling.
	* tree-vrp.c: (check_array_ref): Handle MEM_REF.
	(search_for_addr_array): Likewise.
	(check_array_bounds): Likewise.
	(vrp_stmt_computes_nonzero): Adjust for MEM_REF.
	* tree-ssa-loop-im.c (for_each_index): Handle MEM_REF.
	(ref_always_accessed_p): Likewise.
	(gen_lsm_tmp_name): Likewise.  Handle ADDR_EXPR.
	* tree-complex.c (extract_component): Do not handle INDIRECT_REF.
	Handle MEM_REF.
	* cgraphbuild.c (mark_load): Properly check for NULL result
	from get_base_address.
	(mark_store): Likewise.
	* tree-ssa-loop-niter.c (array_at_struct_end_p): Handle MEM_REF.
	* tree-loop-distribution.c (generate_builtin): Exchange INDIRECT_REF
	handling for MEM_REF.
	* tree-scalar-evolution.c (follow_ssa_edge_expr): Handle
	&MEM[ptr + CST] similar to POINTER_PLUS_EXPR.
	* builtins.c (stabilize_va_list_loc): Use the function ABI
	valist type if we couldn't canonicalize the argument type.
	Always dereference with the canonical va-list type.
	(maybe_emit_free_warning): Handle MEM_REF.
	(fold_builtin_memory_op): Simplify and handle MEM_REFs in folding
	memmove to memcpy.
	* builtins.c (fold_builtin_memory_op): Use ref-all types
	for all memcpy foldings.
	* omp-low.c (build_receiver_ref): Adjust for MEM_REF.
	(build_outer_var_ref): Likewise.
	(scan_omp_1_op): Likewise.
	(lower_rec_input_clauses): Likewise.
	(lower_lastprivate_clauses): Likewise.
	(lower_reduction_clauses): Likewise.
	(lower_copyprivate_clauses): Likewise.
	(expand_omp_atomic_pipeline): Likewise.
	(expand_omp_atomic_mutex): Likewise.
	(create_task_copyfn): Likewise.
	* tree-ssa-sccvn.c (copy_reference_ops_from_ref): Handle MEM_REF.
	Remove old union trick.  Initialize constant offsets.
	(ao_ref_init_from_vn_reference): Likewise.  Do not handle
	INDIRECT_REF.  Init base_alias_set properly.
	(vn_reference_lookup_3): Replace INDIRECT_REF handling with
	MEM_REF.
	(vn_reference_fold_indirect): Adjust for MEM_REFs.
	(valueize_refs): Fold MEM_REFs.  Re-evaluate constant offset
	for ARRAY_REFs.
	(may_insert): Remove.
	(visit_reference_op_load): Do not test may_insert.
	(run_scc_vn): Remove parameter, do not fiddle with may_insert.
	* tree-ssa-sccvn.h (struct vn_reference_op_struct): Add
	a field to store the constant offset this op applies.
	(run_scc_vn): Adjust prototype.
	* cgraphunit.c (thunk_adjust): Adjust for MEM_REF.
	* tree-ssa-ccp.c (ccp_fold): Replace INDIRECT_REF folding with
	MEM_REF.  Propagate &foo + CST as &MEM[&foo, CST].  Do not
	bother about volatile qualifiers on pointers.
	(fold_const_aggregate_ref): Handle MEM_REF, do not handle INDIRECT_REF.
	* tree-ssa-loop-ivopts.c
	* tree-ssa-loop-ivopts.c (determine_base_object): Adjust
	for MEM_REF.
	(strip_offset_1): Likewise.
	(find_interesting_uses_address): Replace INDIRECT_REF handling with
	MEM_REF handling.
	(get_computation_cost_at): Likewise.
	* ipa-pure-const.c (check_op): Handle MEM_REF.
	* tree-stdarg.c (check_all_va_list_escapes): Adjust for MEM_REF.
	* tree-ssa-sink.c (is_hidden_global_store): Handle MEM_REF
	and constants.
	* ipa-inline.c (likely_eliminated_by_inlining_p): Handle MEM_REF.
	* tree-parloops.c (take_address_of): Adjust for MEM_REF.
	(eliminate_local_variables_1): Likewise.
	(create_call_for_reduction_1): Likewise.
	(create_loads_for_reductions): Likewise.
	(create_loads_and_stores_for_name): Likewise.
	* matrix-reorg.c (may_flatten_matrices_1): Sanitize.
	(ssa_accessed_in_tree): Handle MEM_REF.
	(ssa_accessed_in_assign_rhs): Likewise.
	(update_type_size): Likewise.
	(analyze_accesses_for_call_stmt): Likewise.
	(analyze_accesses_for_assign_stmt): Likewise.
	(transform_access_sites): Likewise.
	(transform_allocation_sites): Likewise.
	* tree-affine.c (tree_to_aff_combination): Handle MEM_REF.
	* tree-vect-data-refs.c (vect_create_addr_base_for_vector_ref): Do
	not handle INDIRECT_REF.
	* tree-ssa-phiopt.c (add_or_mark_expr): Handle MEM_REF.
	(cond_store_replacement): Likewise.
	* tree-ssa-pre.c (create_component_ref_by_pieces_1): Handle
	MEM_REF, no not handle INDIRECT_REFs.
	(insert_into_preds_of_block): Properly initialize avail.
	(phi_translate_1): Fold MEM_REFs.  Re-evaluate constant offset
	for ARRAY_REFs.  Properly handle reference lookups that
	require a bit re-interpretation.
	(can_PRE_operation): Do not handle INDIRECT_REF.  Handle MEM_REF.
	* tree-sra.c
	* tree-sra.c (build_access_from_expr_1): Handle MEM_REF.
	(build_ref_for_offset_1): Remove.
	(build_ref_for_offset): Build MEM_REFs.
	(gate_intra_sra): Disable for now.
	(sra_ipa_modify_expr): Handle MEM_REF.
	(ipa_early_sra_gate): Disable for now.
	* tree-sra.c (create_access): Swap INDIRECT_REF handling for
	MEM_REF handling.
	(disqualify_base_of_expr): Likewise.
	(ptr_parm_has_direct_uses): Swap INDIRECT_REF handling for
	MEM_REF handling.
	(sra_ipa_modify_expr): Remove INDIRECT_REF handling.
	Use mem_ref_offset.  Remove bogus folding.
	(build_access_from_expr_1): Properly handle MEM_REF for
	non IPA-SRA.
	(make_fancy_name_1): Add support for MEM_REF.
	* tree-predcom.c (ref_at_iteration): Handle MEM_REFs.
	* tree-mudflap.c (mf_xform_derefs_1): Adjust for MEM_REF.
	* ipa-prop.c (compute_complex_assign_jump_func): Handle MEM_REF.
	(compute_complex_ancestor_jump_func): Likewise.
	(ipa_analyze_virtual_call_uses): Likewise.
	* tree-ssa-forwprop.c (forward_propagate_addr_expr_1): Replace
	INDIRECT_REF folding with more generalized MEM_REF folding.
	(tree_ssa_forward_propagate_single_use_vars): Adjust accordingly.
	(forward_propagate_addr_into_variable_array_index): Also handle
	&ARRAY + I in addition to &ARRAY[0] + I.
	* tree-ssa-dce.c (ref_may_be_aliased): Handle MEM_REF.
	* tree-ssa-ter.c (find_replaceable_in_bb): Avoid TER if that
	creates assignments with overlap.
	* tree-nested.c (get_static_chain): Adjust for MEM_REF.
	(get_frame_field): Likewise.
	(get_nonlocal_debug_decl): Likewise.
	(convert_nonlocal_reference_op): Likewise.
	(struct nesting_info): Add mem_refs pointer-set.
	(create_nesting_tree): Allocate it.
	(convert_local_reference_op): Insert to be folded mem-refs.
	(fold_mem_refs): New function.
	(finalize_nesting_tree_1): Perform defered folding of mem-refs 
	(free_nesting_tree): Free the pointer-set.
	* tree-vect-stmts.c (vectorizable_store): Adjust for MEM_REF.
	(vectorizable_load): Likewise.
	* tree-ssa-phiprop.c (phiprop_insert_phi): Adjust for MEM_REF.
	(propagate_with_phi): Likewise.
	* tree-object-size.c (addr_object_size): Handle MEM_REFs
	instead of INDIRECT_REFs.
	(compute_object_offset): Handle MEM_REF.
	(plus_stmt_object_size): Handle MEM_REF.
	(collect_object_sizes_for): Dispatch to plus_stmt_object_size
	for &MEM_REF.
	* tree-flow.h (get_addr_base_and_unit_offset): Declare.
	(symbol_marked_for_renaming): Likewise.
	* Makefile.in (tree-dfa.o): Add $(TOPLEV_H).
	(fold-const.o): Add $(TREE_FLOW_H).
	* tree-ssa-structalias.c (get_constraint_for_1): Handle MEM_REF.
	(find_func_clobbers): Likewise.
	* ipa-struct-reorg.c (decompose_indirect_ref_acc): Handle MEM_REF.
	(decompose_access): Likewise.
	(replace_field_acc): Likewise.
	(replace_field_access_stmt): Likewise.
	(insert_new_var_in_stmt): Likewise.
	(get_stmt_accesses): Likewise.
	(reorg_structs_drive): Disable.
	* config/i386/i386.c (ix86_va_start): Adjust for MEM_REF.
	(ix86_canonical_va_list_type): Likewise.

	cp/
	* cp-gimplify.c (cp_gimplify_expr): Open-code the rhs
	predicate we are looking for, allow non-gimplified
	INDIRECT_REFs.

	testsuite/
	* gcc.c-torture/execute/20100316-1.c: New testcase.
	* gcc.c-torture/execute/pr44468.c: Likewise.
	* gcc.c-torture/compile/20100609-1.c: Likewise.
	* gcc.dg/volatile2.c: Adjust.
	* gcc.dg/plugin/selfassign.c: Likewise.
	* gcc.dg/pr36902.c: Likewise.
	* gcc.dg/tree-ssa/foldaddr-2.c: Remove.
	* gcc.dg/tree-ssa/foldaddr-3.c: Likewise.
	* gcc.dg/tree-ssa/forwprop-8.c: Adjust.
	* gcc.dg/tree-ssa/pr17141-1.c: Likewise.
	* gcc.dg/tree-ssa/ssa-fre-13.c: Likewise.
	* gcc.dg/tree-ssa/ssa-fre-14.c: Likewise.
	* gcc.dg/tree-ssa/ssa-ccp-21.c: Likewise.
	* gcc.dg/tree-ssa/pta-ptrarith-1.c: Likewise.
	* gcc.dg/tree-ssa/20030807-7.c: Likewise.
	* gcc.dg/tree-ssa/forwprop-10.c: Likewise.
	* gcc.dg/tree-ssa/ssa-fre-1.c: Likewise.
	* gcc.dg/tree-ssa/pta-ptrarith-2.c: Likewise.
	* gcc.dg/tree-ssa/ssa-ccp-23.c: Likewise.
	* gcc.dg/tree-ssa/forwprop-1.c: Likewise.
	* gcc.dg/tree-ssa/forwprop-2.c: Likewise.
	* gcc.dg/tree-ssa/struct-aliasing-1.c: Likewise.
	* gcc.dg/tree-ssa/ssa-ccp-25.c: Likewise.
	* gcc.dg/tree-ssa/ssa-pre-26.c: Likewise.
	* gcc.dg/tree-ssa/struct-aliasing-2.c: Likewise.
	* gcc.dg/tree-ssa/ssa-ccp-26.c: Likewise.
	* gcc.dg/tree-ssa/ssa-sccvn-4.c: Likewise.
	* gcc.dg/tree-ssa/ssa-pre-7.c: Likewise.
	* gcc.dg/tree-ssa/forwprop-5.c: Likewise.
	* gcc.dg/struct/w_prof_two_strs.c: XFAIL.
	* gcc.dg/struct/wo_prof_escape_arg_to_local.c: Likewise.
	* gcc.dg/struct/wo_prof_global_var.c: Likewise.
	* gcc.dg/struct/wo_prof_malloc_size_var.c: Likewise.
	* gcc.dg/struct/w_prof_local_array.c: Likewise.
	* gcc.dg/struct/w_prof_single_str_global.c: Likewise.
	* gcc.dg/struct/wo_prof_escape_str_init.c: Likewise.
	* gcc.dg/struct/wo_prof_array_through_pointer.c: Likewise.
	* gcc.dg/struct/w_prof_global_array.c: Likewise.
	* gcc.dg/struct/wo_prof_array_field.c: Likewise.
	* gcc.dg/struct/wo_prof_single_str_local.c: Likewise.
	* gcc.dg/struct/w_prof_local_var.c: Likewise.
	* gcc.dg/struct/wo_prof_two_strs.c: Likewise.
	* gcc.dg/struct/wo_prof_empty_str.c: Likewise.
	* gcc.dg/struct/wo_prof_local_array.c: Likewise.
	* gcc.dg/struct/w_prof_global_var.c: Likewise.
	* gcc.dg/struct/wo_prof_single_str_global.c: Likewise.
	* gcc.dg/struct/wo_prof_escape_substr_value.c: Likewise.
	* gcc.dg/struct/wo_prof_global_array.c: Likewise.
	* gcc.dg/struct/wo_prof_escape_return.c: Likewise.
	* gcc.dg/struct/wo_prof_escape_substr_array.c: Likewise.
	* gcc.dg/struct/wo_prof_double_malloc.c: Likewise.
	* gcc.dg/struct/w_ratio_cold_str.c: Likewise.
	* gcc.dg/struct/wo_prof_escape_substr_pointer.c: Likewise.
	* gcc.dg/struct/wo_prof_local_var.c: Likewise.
	* gcc.dg/tree-prof/stringop-1.c: Adjust.
	* g++.dg/tree-ssa/pr31146.C: Likewise.
	* g++.dg/tree-ssa/copyprop-1.C: Likewise.
	* g++.dg/tree-ssa/pr33604.C: Likewise.
	* g++.dg/plugin/selfassign.c: Likewise.
	* gfortran.dg/array_memcpy_3.f90: Likewise.
	* gfortran.dg/array_memcpy_4.f90: Likewise.
	* c-c++-common/torture/pr42834.c: New testcase.

Added:
    trunk/gcc/testsuite/c-c++-common/torture/pr42834.c
      - copied unchanged from r161654, branches/mem-ref2/gcc/testsuite/c-c++-common/torture/pr42834.c
    trunk/gcc/testsuite/gcc.c-torture/compile/20100609-1.c
      - copied unchanged from r161654, branches/mem-ref2/gcc/testsuite/gcc.c-torture/compile/20100609-1.c
    trunk/gcc/testsuite/gcc.c-torture/execute/20100316-1.c
      - copied unchanged from r161654, branches/mem-ref2/gcc/testsuite/gcc.c-torture/execute/20100316-1.c
    trunk/gcc/testsuite/gcc.c-torture/execute/pr44468.c
      - copied unchanged from r161654, branches/mem-ref2/gcc/testsuite/gcc.c-torture/execute/pr44468.c
Removed:
    trunk/gcc/testsuite/gcc.dg/tree-ssa/foldaddr-2.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/foldaddr-3.c
Modified:
    trunk/gcc/ChangeLog
    trunk/gcc/Makefile.in
    trunk/gcc/alias.c
    trunk/gcc/builtins.c
    trunk/gcc/c-family/c-ada-spec.c   (props changed)
    trunk/gcc/c-family/c-ada-spec.h   (props changed)
    trunk/gcc/c-family/c-common.c   (props changed)
    trunk/gcc/c-family/c-common.def   (props changed)
    trunk/gcc/c-family/c-common.h   (props changed)
    trunk/gcc/c-family/c-cppbuiltin.c   (props changed)
    trunk/gcc/c-family/c-dump.c   (props changed)
    trunk/gcc/c-family/c-format.c   (props changed)
    trunk/gcc/c-family/c-format.h   (props changed)
    trunk/gcc/c-family/c-gimplify.c   (props changed)
    trunk/gcc/c-family/c-lex.c   (props changed)
    trunk/gcc/c-family/c-omp.c   (props changed)
    trunk/gcc/c-family/c-opts.c   (props changed)
    trunk/gcc/c-family/c-pch.c   (props changed)
    trunk/gcc/c-family/c-ppoutput.c   (props changed)
    trunk/gcc/c-family/c-pragma.c   (props changed)
    trunk/gcc/c-family/c-pragma.h   (props changed)
    trunk/gcc/c-family/c-pretty-print.c   (props changed)
    trunk/gcc/c-family/c-pretty-print.h   (props changed)
    trunk/gcc/c-family/c-semantics.c   (props changed)
    trunk/gcc/c-family/c.opt   (props changed)
    trunk/gcc/c-family/stub-objc.c   (props changed)
    trunk/gcc/cfgexpand.c
    trunk/gcc/cgraphbuild.c
    trunk/gcc/cgraphunit.c
    trunk/gcc/config/alpha/alpha.c
    trunk/gcc/config/i386/i386.c
    trunk/gcc/config/rs6000/rs6000.c
    trunk/gcc/config/sh/sh.c
    trunk/gcc/config/spu/spu.c
    trunk/gcc/cp/ChangeLog
    trunk/gcc/cp/cp-gimplify.c
    trunk/gcc/doc/generic.texi
    trunk/gcc/doc/gimple.texi
    trunk/gcc/dwarf2out.c
    trunk/gcc/emit-rtl.c
    trunk/gcc/expr.c
    trunk/gcc/fold-const.c
    trunk/gcc/gimple-fold.c
    trunk/gcc/gimple.c
    trunk/gcc/gimple.h
    trunk/gcc/gimplify.c
    trunk/gcc/ipa-inline.c
    trunk/gcc/ipa-prop.c
    trunk/gcc/ipa-pure-const.c
    trunk/gcc/ipa-struct-reorg.c
    trunk/gcc/matrix-reorg.c
    trunk/gcc/omp-low.c
    trunk/gcc/testsuite/ChangeLog
    trunk/gcc/testsuite/c-c++-common/Wint-to-pointer-cast-1.c   (props changed)
    trunk/gcc/testsuite/c-c++-common/Wint-to-pointer-cast-2.c   (props changed)
    trunk/gcc/testsuite/c-c++-common/Wint-to-pointer-cast-3.c   (props changed)
    trunk/gcc/testsuite/c-c++-common/cpp/normalize-3.c   (props changed)
    trunk/gcc/testsuite/c-c++-common/cpp/warning-directive-1.c   (props changed)
    trunk/gcc/testsuite/c-c++-common/cpp/warning-directive-2.c   (props changed)
    trunk/gcc/testsuite/c-c++-common/cpp/warning-directive-3.c   (props changed)
    trunk/gcc/testsuite/c-c++-common/cpp/warning-directive-4.c   (props changed)
    trunk/gcc/testsuite/g++.dg/plugin/selfassign.c
    trunk/gcc/testsuite/g++.dg/tree-ssa/copyprop-1.C
    trunk/gcc/testsuite/g++.dg/tree-ssa/pr31146.C
    trunk/gcc/testsuite/g++.dg/tree-ssa/pr33604.C
    trunk/gcc/testsuite/g++.dg/warn/Wconversion-null-2.C   (props changed)
    trunk/gcc/testsuite/gcc.dg/plugin/selfassign.c
    trunk/gcc/testsuite/gcc.dg/pr36902.c
    trunk/gcc/testsuite/gcc.dg/struct/w_prof_global_array.c
    trunk/gcc/testsuite/gcc.dg/struct/w_prof_global_var.c
    trunk/gcc/testsuite/gcc.dg/struct/w_prof_local_array.c
    trunk/gcc/testsuite/gcc.dg/struct/w_prof_local_var.c
    trunk/gcc/testsuite/gcc.dg/struct/w_prof_single_str_global.c
    trunk/gcc/testsuite/gcc.dg/struct/w_prof_two_strs.c
    trunk/gcc/testsuite/gcc.dg/struct/w_ratio_cold_str.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_array_field.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_array_through_pointer.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_double_malloc.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_empty_str.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_escape_arg_to_local.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_escape_return.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_escape_str_init.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_escape_substr_array.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_escape_substr_pointer.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_escape_substr_value.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_global_array.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_global_var.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_local_array.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_local_var.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_malloc_size_var.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_single_str_global.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_single_str_local.c
    trunk/gcc/testsuite/gcc.dg/struct/wo_prof_two_strs.c
    trunk/gcc/testsuite/gcc.dg/tree-prof/stringop-1.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/20030807-7.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/forwprop-1.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/forwprop-10.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/forwprop-2.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/forwprop-5.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/forwprop-8.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/loadpre6.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/pr17141-1.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/pta-ptrarith-1.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/pta-ptrarith-2.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/ssa-ccp-21.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/ssa-ccp-23.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/ssa-ccp-25.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/ssa-ccp-26.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/ssa-fre-1.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/ssa-fre-13.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/ssa-fre-14.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/ssa-pre-26.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/ssa-pre-7.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/ssa-sccvn-4.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/struct-aliasing-1.c
    trunk/gcc/testsuite/gcc.dg/tree-ssa/struct-aliasing-2.c
    trunk/gcc/testsuite/gcc.dg/volatile2.c
    trunk/gcc/testsuite/gfortran.dg/array_memcpy_3.f90
    trunk/gcc/testsuite/gfortran.dg/array_memcpy_4.f90
    trunk/gcc/tree-affine.c
    trunk/gcc/tree-cfg.c
    trunk/gcc/tree-complex.c
    trunk/gcc/tree-data-ref.c
    trunk/gcc/tree-dfa.c
    trunk/gcc/tree-eh.c
    trunk/gcc/tree-flow.h
    trunk/gcc/tree-inline.c
    trunk/gcc/tree-into-ssa.c
    trunk/gcc/tree-loop-distribution.c
    trunk/gcc/tree-mudflap.c
    trunk/gcc/tree-nested.c
    trunk/gcc/tree-object-size.c
    trunk/gcc/tree-parloops.c
    trunk/gcc/tree-predcom.c
    trunk/gcc/tree-pretty-print.c
    trunk/gcc/tree-scalar-evolution.c
    trunk/gcc/tree-sra.c
    trunk/gcc/tree-ssa-alias.c
    trunk/gcc/tree-ssa-ccp.c
    trunk/gcc/tree-ssa-dce.c
    trunk/gcc/tree-ssa-forwprop.c
    trunk/gcc/tree-ssa-loop-im.c
    trunk/gcc/tree-ssa-loop-ivopts.c
    trunk/gcc/tree-ssa-loop-niter.c
    trunk/gcc/tree-ssa-operands.c
    trunk/gcc/tree-ssa-phiopt.c
    trunk/gcc/tree-ssa-phiprop.c
    trunk/gcc/tree-ssa-pre.c
    trunk/gcc/tree-ssa-sccvn.c
    trunk/gcc/tree-ssa-sccvn.h
    trunk/gcc/tree-ssa-sink.c
    trunk/gcc/tree-ssa-structalias.c
    trunk/gcc/tree-ssa-ter.c
    trunk/gcc/tree-ssa.c
    trunk/gcc/tree-stdarg.c
    trunk/gcc/tree-vect-data-refs.c
    trunk/gcc/tree-vect-stmts.c
    trunk/gcc/tree-vrp.c
    trunk/gcc/tree.c
    trunk/gcc/tree.def
    trunk/gcc/tree.h

Propchange: trunk/gcc/c-family/c-ada-spec.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-ada-spec.h
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-common.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-common.def
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-common.h
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-cppbuiltin.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-dump.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-format.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-format.h
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-gimplify.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-lex.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-omp.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-opts.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-pch.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-ppoutput.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-pragma.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-pragma.h
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-pretty-print.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-pretty-print.h
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c-semantics.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/c.opt
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/c-family/stub-objc.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/testsuite/c-c++-common/Wint-to-pointer-cast-1.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/testsuite/c-c++-common/Wint-to-pointer-cast-2.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/testsuite/c-c++-common/Wint-to-pointer-cast-3.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/testsuite/c-c++-common/cpp/normalize-3.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/testsuite/c-c++-common/cpp/warning-directive-1.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/testsuite/c-c++-common/cpp/warning-directive-2.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/testsuite/c-c++-common/cpp/warning-directive-3.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/testsuite/c-c++-common/cpp/warning-directive-4.c
            ('svn:mergeinfo' removed)

Propchange: trunk/gcc/testsuite/g++.dg/warn/Wconversion-null-2.C
            ('svn:mergeinfo' removed)


Comment 6 Richard Biener 2010-07-01 09:00:13 UTC
Fixed for 4.6.  Measures are in place to avoid the situation on the branches.
Comment 7 Andrew Pinski 2011-12-22 02:28:15 UTC
*** Bug 45883 has been marked as a duplicate of this bug. ***